<template>
  <v-row>
    <v-col cols="4">
      <v-subheader>
        {{ fieldName }}&nbsp
        <h3 v-if="obligatory" class="primary--text">
          *
        </h3>
        <h3 v-else>
          (opcional)
        </h3>
        :
      </v-subheader>
    </v-col>
    <v-col cols="7">
      <v-menu
        ref="menu"
        v-model="menu"
        :disabled="disabled"
        :close-on-content-click="false"
        :return-value.sync="inputVal"
        transition="scale-transition"
        offset-y
        min-width="auto"
      >
        <template #activator="{ on, attrs }">
          <v-text-field
            v-model="inputVal"
            label="Seleccione fecha"
            prepend-icon="mdi-calendar"
            readonly
            :disabled="disabled"
            v-bind="attrs"
            v-on="on"
            :rules="validation"
          />
        </template>
        <v-date-picker
          v-model="inputVal"
          no-title
          scrollable
          :max="max"
          :show-current="max"
        >
          <v-spacer />
          <v-btn text color="primary" @click="menu = false">
            Cancelar
          </v-btn>
          <v-btn text color="primary" @click="changeDate(inputVal)">
            GUARDAR
          </v-btn>
        </v-date-picker>
      </v-menu>
    </v-col>
  </v-row>
</template>

<script>
export default {
  name: 'PickerField',
  props: {
    'value': { default: '', type: String },
    'fieldName': { default: '', type: String },
    'validation': { type: Array },
    'disabled': { default: false, type: Boolean },
    'obligatory': { default: true, type: Boolean },
    'max': { default: '', type: String },
  },
  data: () => ({
    menu: false,
    date: new Date().toISOString().substr(0, 10),
  }),
  computed: {
    inputVal: {
      get() {
        return this.value;
      },
      set(val) {
        this.$emit('input', val);
      },
    },
  },
  methods: {
    changeDate(inputVal) {
      this.$refs.menu.save(inputVal);
      this.$emit('dateChange', inputVal);
    },
  },
};
</script>
